#include <iostream>
#include <vector>

using namespace std;

string e = "BEEF";
int n;

int idx(char c) {
	if (c >= '0' && c <='9') return c - '0';
	return c - 'A' + 10;
}

int cnt(char t, char f) {
	int i_t = idx(t);
	int i_f = idx(f);
	if (i_t > i_f) {
		swap(i_t, i_f);
	}	
	return min(i_f - i_t, i_t + 16 - i_f);
}

int dist(const char *b) {
	int r = 0;
	for (int i = 0; i < 4; ++i) {
   	    r += cnt(e[i], b[i]);
	}
	return r;
}

int main() {
    string line;
    cin >> line;
    int k;
    cin >> k;
    n = line.size();
    vector<vector<int>> v(n + 1, vector<int>(k + 1, 0));

    for (int i = 4; i <= n; ++i) {
	 for (int j = 0; j <= k; ++j) {
              v[i][j] = v[i-1][j];
	      int cnt = dist(line.data() + i - 4);
	      if (cnt <= j) {
		   v[i][j] = max(v[i][j], v[i - 4][j - cnt] + 1);
              }
	 }
    }

    int ans = 0;

    for (int j = 0; j <= k; ++j) {
	    if (v[n][j] > ans) {
		    ans = v[n][j];
	    }
    }
    cout << ans;
}
